import time, os

from selenium.webdriver.common.action_chains import ActionChains
from remote_selenium.jingdong.mycookies import *
from remote_selenium.jingdong.mysql_db import save_info_to_mysql


def login(driver):
    driver.get("http://www.jd.com")
    # 浏览器最大化
    # driver.maximize_window()
    # 设置固定的浏览器的大小
    # driver.set_window_size(1920,1080)
    driver.find_element_by_class_name("link-login").click()
    driver.find_element_by_link_text("账户登录").click()
    time.sleep(2)
    driver.find_element_by_id("loginname").send_keys("an5456")
    driver.find_element_by_id("nloginpwd").send_keys("dong19871103")
    driver.find_element_by_id("loginsubmit").click()
    save_cookies(driver)


def to_goods_page(driver, name):
    # 回到首页的页面
    driver.get("https://www.jd.com")
    # 定位到电脑上
    computer_element = driver.find_element_by_link_text("电脑")
    # 鼠标悬停在电脑上
    ActionChains(driver).move_to_element(computer_element).perform()
    # 点击笔记本
    time.sleep(2)
    driver.find_element_by_link_text("笔记本").click()
    time.sleep(2)

    # 切换句柄
    handles = driver.window_handles
    index_handle = driver.current_window_handle
    for hendle in handles:
        if hendle != index_handle:
            driver.switch_to_window(hendle)
    if name == 'thinkpad':
        # 点击ThinkPad
        driver.find_element_by_xpath("//*[@id=\"brand-11518\"]/a").click()
    if name == 'dell':
        time.sleep(3)
        driver.find_element_by_xpath("//*[@id=\"brand-5821\"]/a").click()
    # 点击7000以上
    driver.find_element_by_xpath("//*[@id=\"J_selectorPrice\"]/div/div[2]/div/ul/li[7]/a").click()

    # 点击评论数
    driver.find_element_by_xpath("//*[@id=\"J_filter\"]/div[1]/div[1]/a[3]").click()

    # 点击第一款电脑
    driver.find_element_by_xpath("//*[@id=\"plist\"]/ul/li[1]/div/div[1]/a/img").click()

    # 切换句柄
    notebook_handler = driver.current_window_handle
    # 必须重新获取一下handles,因为这里已经有个3个窗口了
    handles = driver.window_handles
    for hendle in handles:
        if hendle != index_handle and hendle != notebook_handler:
            driver.switch_to_window(hendle)

    # # 滑动滚轮
    js = "window.scrollTo(0,400)"
    driver.execute_script(js)

    # 点击规格与包装
    driver.find_element_by_xpath("//*[@id=\"detail\"]/div[1]/ul/li[2]").click()
    # 获取规格与包装的信息
    info_elements = driver.find_elements_by_class_name("Ptable-item")
    # 解析所有的标签
    result_list = []
    # 保存这些信息到文件中
    for info_element in info_elements:
        # 获取到每一行的笔记本的配置信息
        info_element_dict = get_info_element_dict(info_element)
        result_list.append(info_element_dict)
    # 保存这些信息到文件中
    save_goods_info(result_list)

    # 保存信息到MySQL中
    save_info_to_mysql(result_list)


def get_info_element_dict(info_element):
    # 拿到第一列的信息，就是计算机的组成信息
    computer_part = info_element.find_element_by_tag_name("h3")
    # 获取计算机信息中的key值
    computer_info_keys = info_element.find_elements_by_tag_name("dt")
    # 获取计算机信息中的values值  contains是包含函数
    computer_info_value = info_element.find_elements_by_xpath("dl//dd[not(contains(@class,'Ptable-tips'))]")

    # 存储计算机信息中的key和value
    key_and_value_dict = {}

    # 用来存储所有的计算机组成信息的字典
    parts_dict = {}
    for i in range(len(computer_info_keys)):
        key_and_value_dict[computer_info_keys[i].text] = computer_info_value[i].text
    parts_dict[computer_part.text] = key_and_value_dict

    return parts_dict


def save_goods_info(result_list):
    project_path = os.path.dirname(os.getcwd())
    file_path = project_path + "/goods_infos/"
    if not os.path.exists(file_path):
        os.mkdir(file_path)
    with open(file_path + "computers.infos", "a", encoding='utf-8') as f:
        f.write(str(result_list))
        print(result_list)


def to_start(driver, name):
    try:
        # 用一个循环状态来控制是否登录成功
        loop_status = True
        while loop_status:
            # 检验cookies是否生效
            login_status = check_cookies(driver)
            if login_status:
                loop_status = False
            else:
                print("cookies没有生效")
                login(driver)
        to_goods_page(driver, name)
    finally:
        time.sleep(20)
        driver.quit()


def thinkpad_start(driver):
    to_start(driver, "thinkpad")


def dell_start(driver):
    to_start(driver, "dell")
